package portal;

import java.util.ArrayList;
import java.util.Scanner;

public class Course {
    private String name;
    private String courseId;
    private int unitsAmount;
    private int capacity;
    private int currentSize = 0;
    ArrayList<Student> students;

    /**
     * set course info
     * @param name
     * @param unitsAmount amounts of unit each course has
     * @param courseId
     * @param capacity
     */
    public Course(String name , int unitsAmount , String courseId , int capacity){
        this.name = name;
        this.capacity = capacity;
        setCourseId(courseId);
        setUnitsAmount(unitsAmount);
        students = new ArrayList<Student>();
    }

    /**
     * @return course name
     */
    public String getName() {
        return name;
    }

    public int getUnitsAmount() {
        return unitsAmount;
    }

    /**
     * @param unitsAmount
     */
    public void setUnitsAmount(int unitsAmount) {
        if (unitsAmount >=1 && unitsAmount <=3){
            this.unitsAmount = unitsAmount;
        }
        else {
            System.out.println("Invalid request. unit's num must be between 1 & 3. set again.");
            Scanner unit = new Scanner(System.in);
            int un = Integer.parseInt(unit.nextLine());
            setUnitsAmount(un);
        }
    }

    /**
     *
     * @return course id
     */
    public String getCourseId() {
        return courseId;
    }

    public void setCourseId(String courseId) {
        if(courseId.length() == 4) {
            this.courseId = courseId;
        }
        else {
            System.out.println("Invalid course id. enter again.");
            Scanner id = new Scanner(System.in);
            String iD = id.nextLine();
            setCourseId(iD);
        }
    }

    /**
     * @param student who take this course
     */
    public boolean chooseCourse(Student student){
        if (currentSize < capacity){
            students.add(student);
            currentSize++;
            return true;
        }
        else{
            System.out.println("No capacity to add " + student.getName() + " to course " + this.name);
            return false;
        }
    }
    public void removeStudent(Student student){
        students.remove(student);
    }

    /**
     * print course info
     */
    public void printCourse(){
        System.out.print(this.name + ": ");
        for (Student i : students){
            System.out.print(i.getName() + " ");
        }
    }

}
