package portal;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Scanner;

public class Student {
    private String name;
    private int studentId;
    private int average;
    private int maxUnitsToTake ;
    private int coursesWantToTake;
    ArrayList<Course> courses ;

    /**
     * set name & id
     * @param name
     * @param id student id
     */
    public Student(String name , int id , int average , int coursesWantToTake ){
        this.name = name;
        setAverage(average);
        setStudentId(id);
        this.coursesWantToTake = coursesWantToTake;
        maxUnitsToTake = 0;
        courses = new ArrayList<Course>();
    }

    public int getCoursesWantToTake() {
        return coursesWantToTake;
    }

    /**
     * @return student's name
     */
    public String getName() {
        return name;
    }

    /**
     * @param average of scores
     */
    public void setAverage(int average) {
        if(average >= 0 && average <= 20 ) {
            this.average = average;
        }
        else {
            System.out.println("Invalid average. it must be between 1 & 20. set it again.");
            Scanner average2 = new Scanner(System.in);
            int avg = Integer.parseInt(average2.nextLine());
            setAverage(avg);
        }
    }

    /**
     * @return average
     */
    public int getAverage() {
        return average;
    }

    /**
     * @param studentId
     */
    public void setStudentId(Integer studentId) {
        if(studentId.toString().length() == 7) {
            this.studentId = studentId;
        }
        else{
            System.out.println("Invalid student id for " + name + ". enter a valid id.");
            Scanner id = new Scanner(System.in);
            int sId = Integer.parseInt(id.nextLine());
            setStudentId(sId);
        }
    }

    /**
     * add course according to average
     * check whether the student can take this course or not and also error if the student isn't for this college
     * @param course to add
     */
    public void addCourse(Course course){
        if(Integer.parseInt(course.getCourseId())/100 != (studentId/1000)%100) {
            System.out.println("You cannot take this course. it isn't in your college. you must take another.");
            return;
        }
        if(average >= 15){
            if (maxUnitsToTake + course.getUnitsAmount() <= 20) {
                if (courses.size()==0){
                    courses.add(course);course.chooseCourse(this);maxUnitsToTake += course.getUnitsAmount();
                    coursesWantToTake--;
                }
                else {
                    int t=0;
                    for (int i = 0; i < courses.size(); i++) {
                        if (courses.get(i).getName().equals(course.getName())) {
                            t=1;
                            break;
                        }
                    }
                    if(t==0){
                        if(course.chooseCourse(this)){
                            courses.add(course);
                            maxUnitsToTake += course.getUnitsAmount();
                            coursesWantToTake--;
                        }
                    }
                    else {
                        System.out.println("Repetitive unit. take another.");
                    }
                }
            }
            else {
                System.out.println(name + ", Your units must be less than 20. So you should remove some units");
            }
        }
        if(average >= 10 && average<= 15){
            if (maxUnitsToTake + course.getUnitsAmount() < 15){
                if (courses.size()==0){
                    if(course.chooseCourse(this)){
                    courses.add(course);maxUnitsToTake += course.getUnitsAmount();
                    coursesWantToTake--;
                    }
                }
                else {
                    int t=0;
                    for (int i = 0; i < courses.size(); i++) {
                        if (courses.get(i).getName().equals(course.getName())) {
                            t=1;
                            break;
                        }
                    }
                    if(t==0){
                        if(course.chooseCourse(this)){
                            courses.add(course);
                            maxUnitsToTake += course.getUnitsAmount();
                            coursesWantToTake--;
                        }
                    }
                    else {
                        System.out.println("Repetitive unit. take another.");
                    }
                }
            }
            else {
                System.out.println(name + ", Your units must be less than 15. So you can't add this unit.");
            }
        }
        if(average <= 10 ){
            if (maxUnitsToTake <= 15){
                System.out.println("You can't take units");
                coursesWantToTake =0;
                return;
            }
        }
    }


    /**
     * @param course to remove
     */
    public void removeCourse(Course course){
        courses.remove(course);
        course.removeStudent(this);
        coursesWantToTake++;
        maxUnitsToTake-=course.getUnitsAmount();
    }

    /**
     * print student's info
     */
    public void printStudent(){
        System.out.print(this.name + ": ");
        for (Course i : courses){
            System.out.print(i.getName() + " ");
        }
    }
}
